<template>
  <ObDatepicker
    ref="datepicker"
    :value="value"
    :class="[
      'obInputField obDatepickerField',
      highlightClass,
      { 'withTime': valueType === 'DATETIME' }
    ]"
    :data-qa="dataQa"
    :readonly="isDisabled"
    :is-time="valueType === 'DATETIME'"
    :label="null"
    @open="onFieldFocus"
    @focus="onFieldFocus"
    @blur="resetState"
    @input="onInput($event)"
  />
</template>

<script>
import ObDatepicker from '../../../obDatePickerConstructor/index'
import tableRowMixin from './tableRowMixin'

export default {
  name: 'TableRowDatepicker',
  components: {
    ObDatepicker
  },
  mixins: [
    tableRowMixin
  ],
  mounted () {
    this.value = this.column.isEditHtml ? this.getTableCellHtml(this.data.item, this.column) : this.data.item[this.column.key]
  },
  methods: {
    async onInput (value) {
      await this.onFieldChanged(value)

      this.resetState()
    },
    resetState () {
      this.onFieldBlur()

      this.$emit('reset-state') // Fixed error with multiple datepicker sending
    }
  }
}
</script>
